//ATMEGA1281602LCDʾ
//뻷 ICCAVR 7.16A
//ϵͳʱ7.3728MHZ˿λΪⲿƵʯӢ񵴣ʱ4.1ms
//˵Ԫ༭
//ڣ2010.01.14

//***********************************************************************
//			ļ
//***********************************************************************

#include <string.h>
#include <stdio.h>
#include <delay.h>
#include <iom128v.h>

#define uchar unsigned char
#define uint  unsigned int

#define RS_CLR	PORTF &= ~(1 << PF1)                 //RSõ
#define RS_SET	PORTF |= (1 << PF1)                  //RSø

#define RW_CLR	PORTF &= ~(1 << PF2)                 //RWõ
#define RW_SET	PORTF |= (1 << PF2)                  //RWø

#define EN_CLR	PORTF &= ~(1 << PF3)                 //Eõ
#define EN_SET	PORTF |= (1 << PF3)                  //Eø

#define Data_IO	        PORTA                //Һݿ
#define Data_DDR        DDRA                 //ݿڷĴ
#define D_LE0	        PORTD &= ~(1 << PD4) //ܶολΪ0˿
#define D_LE1           PORTD |= (1 << PD4)  //ܶολΪ1˿һ
#define W_LE0	        PORTD &= ~(1 << PD5) //λλΪ0
#define W_LE1           PORTD |= (1 << PD5)  //λλΪ1

//*************************************************************************
//			ʼӳ
//*************************************************************************
void system_init()
{

	Data_IO = 0xFF;				        //ƽ
	Data_DDR = 0xFF;				        //
	PORTF = 0xFF;                       //ƽ
	DDRF = 0xFF;                        //
    PORTD=0xFF;
	DDRD=0xFF;
	D_LE1;                             //صܣʾ                   
    W_LE1;                     
    Data_IO=0xFF;                      //            
    W_LE0; 
}

//***********************************************************************
//	ʾд뺯
//***********************************************************************


void LCD_write_com(unsigned char com) 
{	
	RS_CLR;
	RW_CLR;
	EN_SET;
	Data_IO = com;
	delay_nms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾд뺯
//***********************************************************************

void LCD_write_data(unsigned char data) 
{
	RS_SET;
	RW_CLR;
	EN_SET;
	Data_IO = data;
	delay_nms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
	LCD_write_com(0x01);
	delay_nms(5);
}
//***********************************************************************
//	ʾַд뺯
//***********************************************************************

void LCD_write_str(unsigned char x,unsigned char y,unsigned char *s) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);
    }
    else 
    {
    	LCD_write_com(0xC0 + x);
    }
    
    while (*s) 
    {
    	LCD_write_data( *s);
    	s ++;
    }
}
//***********************************************************************
//	ʾַд뺯
//***********************************************************************

void LCD_write_char(unsigned char x,unsigned char y,unsigned char data) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);
    }
    else 
    {
    	LCD_write_com(0xC0 + x);
    }
    
    LCD_write_data( data);  
}
//***********************************************************************
//	ʾʼ
//***********************************************************************

void LCD_init(void) 
{
	DDRA = 0xFF;				        //I/Oڷ
	DDRA |= (1 << PA5) | (1 << PA6) | (1 << PA7);
	LCD_write_com(0x38);				//ʾģʽ
	delay_nms(5);
	LCD_write_com(0x08);				//ʾر
	delay_nms(5);
    LCD_write_com(0x01);				//ʾ
	delay_nms(5);
    LCD_write_com(0x06);				//ʾƶ
	delay_nms(5);
	LCD_write_com(0x0C);				//ʾ
    delay_nms(5);
}

//*************************************************************************
//			
//*************************************************************************
void main(void) 
{

	unsigned char i;
	unsigned char *p;
        system_init();                                //ϵͳʼIO
	delay_nms(100);                                //ʱ100ms
	LCD_init();                                   //Һʼ

 while (1) 
   {
		i = 1;
		p = "zhongxingdianzi";                     //ַʾ
		LCD_clear();
		LCD_write_str(0,0,"Welcome");
		delay_nms(250);
		
		while (*p) {
			LCD_write_char(i,1,*p);          //ַʾ
			i ++;
			p ++;
			delay_nms(250);                   //ʱ250ms
			}
		delay_nms(250);
  }
}
